<template>
  <div>
    <filter-panel/>
    <ob-table
        ref="ob-table"
        :columns="columns"
        @select="openInNewTab"
        @on-change-filter-button="onChangeFilterButton"
        :functionalPanel="true"
        :filter-buttons="isClicar && !isOrderAll ? filterButtons : []"
        is-fixed-header
        :is-functional-sort="false"
        :is-functional-group="false"
        :remote-opt="{
          method: getOrders,
          arguments: {
            url: $route.query.tab
          }
        }"
        :remote-trigger="$route.query"
        data-qa="orderListTable"
        class="orders-page"
        :component-unique-key="tableUniqueKey"
        @on-column-filter-changed="onFilterChanged"
    >

      <div slot="typeOrder" slot-scope="{data}">
        <type-order :order="data.item"/>
      </div>
      <div slot="caution" slot-scope="{data}">
        <caution :info="data.item"/>
      </div>
      <div slot="isNumberOrder" slot-scope="{data}">
        <number-order :item="data.item"/>
      </div>
      <div slot="cargoType" slot-scope="{data}">
        <cargo-type :data="data.item"/>
      </div>
      <div slot="route" slot-scope="{data}">
        <routes
          :start-address="data.item.fromLocationTitle"
          :end-address="data.item.toLocationTitle"
          :count="0"
        />
      </div>
      <div slot="spotQuota" slot-scope="{data}">
        <spot-quota :data="data.item" />
      </div>
      <div slot="approaching" slot-scope="{data}">
        <Approaching :data="data.item" />
      </div>

      <table-is-empty slot="noneContent"/>

    </ob-table>
  </div>

</template>

<script>
  import api from '@/api'
  import FilterPanel from "../../filterPanel"
  import ObTable from "common-components/src/obComponents/obTable"
  import TypeOrder from "../slots/typeOrder"
  import Caution from "../slots/caution"
  import NumberOrder from "../slots/numberOrder"
  import CargoType from "../slots/cargoType"
  import Routes from "../slots/routes"
  import SpotQuota from "../slots/spotQuota"
  import TableIsEmpty from "../tableIsEmpty"
  import Approaching from "../slots/approaching"
  import commonMethods from '@/mixins/order-list-mixin.js'
  import moment from "moment"
  import { formatNumber } from "common-components/src/helpers/common"
  import { mapGetters } from "vuex"

  export default {
    name: 'client',
    components: {
      FilterPanel,
      ObTable,
      TypeOrder,
      Caution,
      NumberOrder,
      CargoType,
      Routes,
      TableIsEmpty,
      SpotQuota,
      Approaching
    },
    mixins: [
      commonMethods
    ],
    data () {
      return {
        itemsFilter: [],
        tableFilters: [],
        iconMap:{
          administrator: 'administrator',
          moderator: 'system-moderator',
          expeditor: 'domain-owner',
          client: 'client',
          carrier: 'carrier',
          agent: 'agent',
          anonymous: 'profile',
          clicar: 'domain-owner'
        },
        filterButtons: [
          {
            title: 'Все',
            uuid: 'EXECUTION',
            _isActive: true
          },
          {
            html: '<span style="font-size: 18px; color: red" class="icon inherit clock"/>',
            _isActive: false
          },
          {
            title: 'Контрактован',
            uuid: 'CONTRACTED',
            _isActive: false
          },
          {
            title: 'Исполнение',
            uuid: 'IN_PROCESS',
            _isActive: false
          }
        ]
      }
    },
    computed: {
      ...mapGetters({
        isClicar: 'user/isClicar'
      }),
      tableUniqueKey () {
        const { AccountOrdersAll, AccountPerformerOrdersClient, AccountClientsOrders } = this.$uniqueTableKeys
        const routeMap = {
          orders__all__orders: AccountOrdersAll,
          order__performerer: AccountPerformerOrdersClient,
          default: AccountClientsOrders
        }
        return routeMap[this.$route?.name] || routeMap.default
      },
      columns () {
        let columns = [
          {
            title: '',
            key: 'typeOrder',
            slotName: 'typeOrder',
            sortDisable: true
          },
          {
            title: '№ заказа клиента',
            key: 'number',
            slotName: 'isNumberOrder'
          },
          {
            title: 'Внешний № заказа клиента',
            key: 'externalNumber',
            html: ({externalNumber}) => this.transformText(externalNumber)
          },
          {
            title: 'Спот, квота',
            key: 'spotQuota',
            slotName: 'spotQuota',
            sortDisable: true
          },
          {
            title: 'статус',
            key: 'statusTitle',
          },
          {
            title: 'дата создания',
            key: 'createdAt',
            html: (data) => moment(data.createdAt).format('DD.MM.YYYY'),
            withFilter: true,
            valueType: 'DATE'
          },
          {
            title: "Грузовладелец",
            key: "clientTitle",
            withFilter: true
          },
          {
            title: 'заколь-\nцовки',
            key: 'approaching',
            action: true,
            slotName: 'approaching',
            sortDisable: true
          },
          {
            title: 'модальность',
            key: 'cargoTypeTitle',
            slotName: 'cargoType'
          },
          {
            title: 'Маршрут',
            key: 'fromLocationTitle,toLocationTitle',
            slotName: 'route',
            withFilter: true
          },
          {
            title: 'План: погрузка',
            key: 'arriveOrDepartureDt',
            withFilter: true,
            valueType: 'DATE'
          },
          {
            title: 'сумма без ндс',
            key: 'tariffWithoutVat',
            isAlignRight: true,
            html: ({tariffWithoutVat}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(tariffWithoutVat / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`,
            withFilter: true,
            valueType: 'MONEY'
          },
          {
            title: this.isTab === "carrier" ? 'НДС перевозчика' : 'ндс',
            key: 'vatValue',
            isAlignRight: true,
            html: ({vatValue}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(vatValue / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`,
            withFilter: true,
            valueType: 'MONEY'
          },
          {
            title: 'сумма итого',
            key: 'tariffWithVat',
            isAlignRight: true,
            html: ({tariffRur}) =>
              `<div class="price-right">
                <span style="white-space: nowrap;">
                  ${formatNumber(tariffRur / 100, {dot: 2}) + " ₽"}
                </span>
              </div>`,
            withFilter: true,
            valueType: 'MONEY'
          }
        ]

        return columns.filter(item => {
          const approachingCondition = (data) => (this.params.transportationWay === 'FTL' && this.isClicar) || data.key !== 'approaching'

          return approachingCondition(item)
        })
      }
    },
    methods: {
      async getOrders(
              {
                page,
                size,
                query,
                status,
                sort,
                url = this.filterButtons.find(key => key._isActive)?.uuid,
                params = this.$route.query,
                filter = this.tableFilters
              }) {
        this.clearAdditionalItemsFilter();
        try {
          if (this.isOrderAll) {
            url = 'ALL'
          }
          let orderData = await api.orderProcess.getOrdersList({ page, size, query, status, sort, url, filter }, params)
          const listKeys = ['serviceOptions', 'resourceTypeOptions', 'statusOptions', 'logistOptions', 'authorOptions']

          listKeys.forEach(key => {
            this.setStatusFilter({
              title: key,
              params: Object.keys(orderData[key]).length ? this.transformArray(orderData[key]) : []
            })
          })

          orderData.orders.content = orderData.orders.content.map((item) => {
            return {
              ...item,
              tariffRur: item.tariffWithVat || item.tariffRur,
              arriveOrDepartureDt: item.arriveOrDepartureDt ? moment(item.arriveOrDepartureDt).format("DD.MM.YYYY") : "Не указан",
              roleIcon: this.iconMap[(item.clientRoleCode || 'anonymous').toLowerCase()]
            }
          })

          return orderData.orders
        } catch (e) {
          console.error(e)
          this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
          return []
        } finally {
          this.setUpdateLoader(false)
        }
      },
      onFilterChanged ({ column, filters }) {
        this.tableFilters.push(column.key + "," + filters)
      },
    }
  }
</script>
